# -*- coding: utf-8 -*-
from common import messager, settings, util, xdg

class LibraryPanelInterface(object):
	
	
	def fillModel(self, garbageFromConnect=None, force_reload=False, word='', e=None):
		'''
			Fill model with tracks from db according to the structure of selected mode
		'''
		tagIndexes = {"title":2, "artist":4, "album":3, "genre":5, "rating":8, "year":9}
		
		global icon_size
		icon_size = settings.get_option('music/panel_icon_size', 32)
		
		
		def getValueOfLevel(track_line, level):
			'''
				@param track_line : line number of track in self.tracks[mode]
				@level : deep level -index of level in displaying mode
					ex of displaying mode ('artist, 'album', 'title') level 0 = artist, level 2 = title, etc...
			'''
			try:
				value = track_line[tagIndexes[mode[level]]]
				if tagIndexes[mode[level]] == 8: # Rating casted to str in order to be able to use find() on it for search purpose
					value = str(value)
			except IndexError:
				value = None
			return value
			
			
		def isSameContainer(track_line, level, cond):
			same = True
			for i in xrange(level+1):
				same = same and getValueOfLevel(track_line, i) == cond[i]

			return same
			
			
		def processContainer(level, line, selection, add_all=False, cond=[]):
			'''
				This method create a selection of matching tracks
				
				@param line : the line from where we start processing
				@param selection : parent dictionnary, each key is a LINE number and is linked to another dict (except for last level) that have the same structure
			'''

			if(level == maxLevel): # If we're on the last level of display mode, its means we're processing a track
				if(add_all or tracks[line][2].lower().find(word) != -1):
					count = tracks[line][7]
					rated = int(tracks[line][8] != 0)
					if rated:
						count_rated = count
					else:
						count_rated = 0
						
					selection['children'][line] = {'props':{'count':count, 'rating':tracks[line][8], 'rated':rated, 'count_rated':count_rated} }

				# Line fully processed, going to the next one
				i = line + 1

				
			else: # We have to continue "digging" and add every child of this node
				
				elt = getValueOfLevel(tracks[line], level)
				cond = list(cond)
				cond.append(elt)
				

				
				if(add_all == False  and getValueOfLevel(tracks[line], level).lower().find(word) != -1):
					add_all = True
					
				new = {'children':{}, 'props':{'count':0, 'rating':0, 'rated':0, 'count_rated':0}}
				

				# While there still tracks AND we're still on the same container :
				while(line < len(tracks) and isSameContainer(tracks[line], level, cond)):
					# Same value on this level, thus we go down and repeat the scheme
					line = processContainer(level+1, line, new, add_all, cond)
					
				if(len(new['children']) > 0 or getValueOfLevel(tracks[line-1], level).lower().find(word) != -1): # If a parentNode contains word or has children
					selection['children'][line-1] = new
					if(add_all == False):
						self.expand[level].append(line-1)
				

					
				
				# Line not fully processed yet, so we stay on it :
				i = line
			
			try: # We add playcount to parent
				selection['props']['count'] += selection['children'][i-1]['props']['count']
				selection['props']['rating'] += selection['children'][i-1]['props']['rating']
				selection['props']['rated'] += selection['children'][i-1]['props']['rated']
				selection['props']['count_rated'] += selection['children'][i-1]['props']['count_rated']
					
			except KeyError:
				pass
			
			return i
				
				
		
		

			
		try:
			if(force_reload is True):
				self.tracks[self.mode] = self.mdb.loadTracks(self.mode)
				tracks = self.tracks[self.mode]
			else:
				tracks = self.tracks[self.mode]
		except KeyError:
			self.tracks[self.mode] = self.mdb.loadTracks(self.mode)
			tracks = self.tracks[self.mode]
		

		mode = eval(self.mode)
		maxLevel = len(mode) - 1
		
		self.expand = []

		def addSelection(parentNode, level, selection):
			
			for line in selection['children'].iterkeys():
				child = selection['children'][line]
				if(child['props']['rated'] == 0):
					burn = 0
				else:
					burn = float(child['props']['count_rated']) / float(child['props']['rated'] +1)
					#burn = float(child['props']['count']) / float(child['props']['rated'] +1) FIXME create a setting to differentiate these twos
				
				
				child_node = self.append(self.model, [None, tracks[line][0], getValueOfLevel(tracks[line], level), child['props']['count'], child['props']['rating'], burn, "%.2f" % burn, False, mode[level]], parentNode)
				if(level < len(mode)-1):
					if line in self.expand[level]:
						self.addExpandPath(self.model, child_node)
					addSelection(child_node, level+1, child)
			#if(level == 1):
				#child_node = parentNode.append(LibraryItem(None, 0, None, 0, 0, 0, None, True))

			
			

		@util.threaded
		def processLoading():
			#time.sleep(1)
			
			self.notLoading.wait()
			self.notLoading.clear()
			level = 0
			line = 0

			i = 0
			while(line < len(tracks)):
				
				self.expand = [[], [], [], [], []]
				self.expand_paths = []
				self.selection = {'children':{}, 'props':{'count':0, 'rating':0, 'rated':0}}
				line = processContainer(0, line, self.selection)
				
				
				self.beginInsertRows(self.model, i)
				i+=1
				
				addSelection(None, 0, self.selection)
				self.endInsertRows(self.model, self.expand_paths)
				

			if(e != None):
				e.set() # Work ended
			self.notLoading.set()
			
			
		
		
		self.clear(self.model)
		processLoading()