# -*- coding: utf-8 -*-
from common import messager, settings
import gtk, glib
import gobject


class Core(gobject.GObject):
	"""
		Object that contain all Bullseye core widgets
		TODO flat univers, flat categories
		TODO check if files still exist fichiers (on load + routine)
		TODO ability to delete files (from DB & from disk)
		TODO drag'n'drop in & from folders
		TODO IN PROGRESS FOR QT open external track files (mime + isLoaded(musicSection)) + handle drop event for that
		
		
		FIXME stop flag doesn't work when track has temp flag
		TODO add a tableview for UC Modules (which will be an elementSelector like iconSelector already is)
		TODO add a QueueManager for UC Modules; queue type (~ elementSelector) might be defined from base depend on container
		TODO moveToUCStrucutre : filter with CriterionManager
		TODO param module in settings : add new modules, set external program, indexed extensions, etc
		TODO dbus control
	"""
	
	__gsignals__ = { "module-loaded": (gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE, (str,)) }
	
	def __init__(self):
		gobject.GObject.__init__(self)
		from data.db import MainDB
		
		
		self.DB = MainDB()
		
		self.loadedModules = []
		self.managers = {}
		
		# **** GRAPHICAL STUFF ****

		self.mainWindow = gtk.Window()
		self.mainWindow.move(settings.get_option('gui/window_x', 50), settings.get_option('gui/window_y', 50))
		self.mainWindow.resize(settings.get_option('gui/window_width', 700), settings.get_option('gui/window_height', 500))
		if(settings.get_option('gui/maximized', False)):
			self.maximized = True
			self.mainWindow.maximize()
		else:
			self.maximized = False
		
		self.VBox_Main = gtk.VBox()
		
		self.NB_Main = gtk.Notebook()
		self.NB_Main.set_tab_pos(gtk.POS_LEFT)

		print(self.mainWindow.set_icon_from_file('icons/bullseye.png'))
		messager.connect(self.addShortcuts, 'someShortcuts')
		
		
		
		
		# Music
		if settings.get_option('music/enabled', True):
			self.HPaned_Music = gtk.HPaned()
			if(settings.get_option('music/preload', False)):
				glib.idle_add(self.loadMusic)
			else:
				B_loadMusic = gtk.Button(_('Load'))
				B_loadMusic.connect('clicked', self.loadMusic)
				self.HPaned_Music.pack1(B_loadMusic)
				
			label = gtk.Label(_('Music'))
			label.set_angle(90)
			self.NB_Main.append_page(self.HPaned_Music, label)
		

		
		# Pictures
		if settings.get_option('pictures/enabled', True):
			Box_PicturesMain = gtk.VBox()
			if(settings.get_option('pictures/preload', False)):
				from uc_sections.pictures.image_widget import ImageWidget
				
				Box_UpperP = gtk.HBox()
				
				display = self.mainWindow.get_screen().get_display()
				imageWidget = ImageWidget(display)
				
				Box_ControlsP = gtk.HBox()
				self._imageSelector = iconselector.ImageSelector(imageWidget, Box_ControlsP)
				SW_IconsP = gtk.ScrolledWindow()
				SW_IconsP.set_size_request(-1, 170)
				SW_IconsP.add(self._imageSelector)

				self._imagePanel = UC_Panel("image", self._imageSelector)

				Box_UpperP.pack_start(self._imagePanel ,False)
				Box_UpperP.pack_start(imageWidget)
				
				Box_PicturesMain.pack_start(Box_UpperP)
				Box_PicturesMain.pack_start(SW_IconsP, False)
				Box_PicturesMain.pack_start(Box_ControlsP, False)
				
				
			else:
				B_loadPictures = gtk.Button(_('Load'))
				B_loadPictures.connect('clicked', self.loadModule, 'pictures')
				Box_PicturesMain.pack_start(B_loadPictures)

			label = gtk.Label(_('Pictures'))
			label.set_angle(90)
			self.NB_Main.append_page(Box_PicturesMain, label)
			
		# Videos
		if settings.get_option('videos/enabled', True):
			Box_Video = gtk.VBox()
			if(settings.get_option('videos/preload', False)):
				self.loadModule('videos')
			else:
				B_loadVideos = gtk.Button(_('Load'))
				B_loadVideos.connect('clicked', self.loadModule, 'videos')
				Box_Video.pack_start(B_loadVideos)
				
			label = gtk.Label(_('Videos'))
			label.set_angle(90)
			self.NB_Main.append_page(Box_Video, label)




		
		
		# Bars
		from gui.menubar import StatusBar
		self.statusBar = StatusBar()
		self.Label = gtk.Label(_("Init complete"))
		self.statusBar.pack_start(self.Label)
		messager.connect(self.notify, "statusNotification")
		

		self.VBox_Main.pack_end(self.statusBar, False)
		self.VBox_Main.pack_end(self.NB_Main)
		self.mainWindow.add(self.VBox_Main)
		
		

		
		self.mainWindow.connect('window-state-event', self.on_window_state_change)
		self.mainWindow.connect('configure-event', self.on_window_resize)
		self.mainWindow.connect('destroy', self.on_window_destroy)
		
		self.NB_Main.connect('switch-page', self.onModuleChanged)
		
		#glib.idle_add(self.onReady)
		self.onReady()
		
		
	def addShortcuts(self, accelGroup):
		self.mainWindow.add_accel_group(accelGroup)
	
	
	def loadModule(self, senderWidget, section):
		from uc_sections.manager import UCManager
		widget = UCManager(section, self.mainWindow)
		self.managers[section] = widget

		if type(senderWidget).__name__ != 'VBox':
			senderWidget = senderWidget.get_parent() # FIXME parentBox is an empty VBox in which we pack a VBox
			senderWidget.destroy()
		else:
			for child in senderWidget:
				child.destroy()
		senderWidget.pack_start(widget)
		
		self.loadedModules.append(section)
		self.emit('module-loaded', section)
			
	
	def loadMusic(self, button=None):
		from music.queue import QueueManager
		from music.musicpanel import LibraryPanel, PlaylistBrowser
		from music.playerwidget import PlayerWidget
		
		if(button is not None):
			button.destroy()
		else:
			self.HPaned_Music.get_child1().destroy()
		
		Left_music_box = gtk.VBox()
		Right_music_box = gtk.VBox()
		
		backend = (settings.get_option('music/playback_lib', 'GStreamer'))
		if(backend == 'VLC'):
			from media import vlcplayer
			self.player = vlcplayer.MusicPlayer(Box_PlayerM)
		elif(backend == 'MPlayer'):
			from media import mplayers
			self.player = mplayers.MusicPlayer(Box_PlayerM)
			Right_music_box.pack_start(self.player, False)
		else:
			from media.player import Player
			self.player = Player()
			
		playerWidget = PlayerWidget(self.player)
		self.queueManager = QueueManager(playerWidget)
		
		NB_PanelM = gtk.Notebook()
		self.library_panel = LibraryPanel(self.DB, self.queueManager)
		self.playlistBrowser = PlaylistBrowser(self.DB, self.queueManager)
		NB_PanelM.append_page(self.library_panel, gtk.Label(_("Library")))
		NB_PanelM.append_page(self.playlistBrowser, gtk.Label(_("Playlists")))
		

		Left_music_box.pack_start(NB_PanelM)
		Right_music_box.pack_start(self.queueManager)
		Right_music_box.pack_start(playerWidget, False)
		
		self.HPaned_Music.pack1(Left_music_box, False, False)
		self.HPaned_Music.pack2(Right_music_box)

		self.HPaned_Music.set_position(settings.get_option('music/paned_position', 200))
		self.HPaned_Music.connect('notify::position', self.onPanedPositionChanged, 'music/paned_position')
		
		self.HPaned_Music.show_all()
		self.loadedModules.append('music')
		self.emit('module-loaded', 'music')
	
	def notify(self, message):
		self.Label.set_text(message)
		

	def onModuleChanged(self, notebook, page, index):
		if(index == 0 and 'music' not in self.loadedModules):
			glib.idle_add(self.loadMusic)
		if(index == 1 and 'pictures' not in self.loadedModules):
			self.loadModule(notebook.get_nth_page(index), 'pictures')
		elif(index == 2 and 'videos' not in self.loadedModules):
			self.loadModule(notebook.get_nth_page(index), 'videos')
			
	def onReady(self):
		if len(settings.get_option('music/folders', [])) == 0:
			dialog = gtk.Dialog(title=_('No indexed folders'), buttons=(gtk.STOCK_NO, gtk.RESPONSE_REJECT, gtk.STOCK_YES, gtk.RESPONSE_ACCEPT))
			box = dialog.get_content_area()
			box.pack_start(gtk.Label(_('Set indexed folders now ?')), False, 5, 5)
			box.show_all()
			reponse = dialog.run()
			dialog.destroy()
			if(reponse == gtk.RESPONSE_ACCEPT):
				from gui import modales
				modales.SettingsEditor('folders')
			
		
	def on_window_destroy(self, widget):
		from data.db import DB
		DB.saveCache()
		settings.set_option('gui/maximized', self.maximized)
		
		if('music' in self.loadedModules):
			self.player.stop()
			self.queueManager.save_state()
		if('videos' in self.loadedModules):
			self.managers['videos'].videoPlayerWidget.stop()
	
		settings.MANAGER.save()
		settings.MANAGER.saveTimer.cancel()
		print(_('Closing the eye...'))
		gtk.main_quit()
		
	def on_window_resize(self, widget, event):
		if(not self.maximized):
			settings.set_option('gui/window_x', event.x)
			settings.set_option('gui/window_y', event.y)
			settings.set_option('gui/window_width', event.width)
			settings.set_option('gui/window_height', event.height)
			
	def on_window_state_change(self, widget, event):
		if event.new_window_state == gtk.gdk.WINDOW_STATE_MAXIMIZED:
			self.maximized = not self.maximized
		
	def onPanedPositionChanged(self, paned, position, setting):
		"""
			@param setting : string containing value of param that this function will update
		"""
		settings.set_option(setting, paned.get_position())