# -*- coding: utf-8 -*-
import vlc
import os
import sys

from common import messager

#instance = vlc.Instance()
class Player(object):
	
	def __init__(self):
		#self._player = instance.media_player_new()
		self.backend = 'VLC'
		self.connectedWidgets = []
		self._player = vlc.MediaPlayer()
		#self._player.event_manager().event_attach(vlc.EventType.MediaPlayerEndReached, self.on_message)
		
		


	@property
	def duration(self):
		try:
			value = self._player.get_length()
		except:
			value = -1

		return value
        
	@property
	def percentage(self):
		pos = round(self._player.get_position(), 2)
		if(pos == 1.0):
			messager.diffuser('need_piste_suivante', self, 'eos')
		return pos
			
	@property
	def status(self):
		def formatPosition(secs):
			minutes = 0
			while secs > 59:
				minutes += 1
				secs -= 60
				
			if secs < 10:
				secs = "0" + str(secs)
			else:
				secs = str(secs)
			value = str(minutes) + ":" + secs
			return value

		try:
			secs = self.position / 1000
			value = formatPosition(secs)
		except:
			value = "Nothing"
		return value
		
	def addConnectedWidget(self, playerWidget):
		''' This allow me to not use gsignal and qt signal'''
		self.connectedWidgets.append(playerWidget)

	def get_volume(self):
		return self._player.get_property('volume')

	def set_volume(self, volume):
		self._player.set_property('volume', volume)

	volume = property(fget=get_volume, fset=set_volume)

	def get_position(self):
		return self._player.get_time()

	def set_position(self, position):
		self._player.set_position(position)

	position = property(fset=set_position, fget=get_position)
		
	
	def playTrack(self, element):
		#element.path.encode('latin-1')
		self.load(element.path.encode( "utf8" ))
		self.play()

	def load(self, filename):
		self._player.set_mrl(filename)

	def play(self):
		self._player.play()
		for pwidget in self.connectedWidgets:
			pwidget.startUpdatingProgress()

	def pause(self):
		self._player.pause()
		for pwidget in self.connectedWidgets:
			pwidget.stopUpdatingProgress()

	def stop(self, arret_total=None):
		self._player.stop()
		for pwidget in self.connectedWidgets:
			pwidget.stopUpdatingProgress(True)
		
	def is_paused(self):
		return (not self._player.is_playing() and self.position != -1)
		
	def isStopped(self):
		return (not self._player.is_playing() and self.position == -1)
	
	def is_playing(self):
		return self._player.is_playing()
	
	def on_message(self, event):
		messager.diffuser('need_piste_suivante', self, 'eos')
		
	def on_volume_change(self, widget, value):
		self.volume = value
	
	def seekTo(self, pos):
		self.position = pos * self.position / 100
		
	def setUpGtkVideo(self, widget):
		self.movie_window = widget
		if sys.platform == 'win32':
			self._player.set_hwnd(self.movie_window.window.handle)
		else:
			self._player.set_xwindow(self.movie_window.window.xid)
		return True
		
	def setUpQtVideo(self, widget):
		if sys.platform == "linux2": # for Linux using the X Server
			self._player.set_xwindow(widget.winId())
		elif sys.platform == "win32": # for Windows
			self._player.set_hwnd(widget.winId())
		elif sys.platform == "darwin": # for MacOS
			self._player.set_agl(widget.windId())
		
	def togglePause(self):
		if self.is_paused():
			self.play()
		elif self.isStopped():
			messager.diffuser('need_piste_suivante', self, 'click')
		else:
			self.pause()
			

